%define contentdir /var/www
%define apache_ver 1.3.12
%define mod_ssl_ver 2.6.6

Summary: The most widely used Web server on the Internet.
Name: apache
Version: %{apache_ver}
Release: 25
Group: System Environment/Daemons
Source: ftp://ftp.apache.org/apache/dist/apache_%{version}.tar.gz
Source1: ftp://ftp.modssl.org/source/mod_ssl-%{mod_ssl_ver}-%{version}.tar.gz
Source2: spacer48.png
Source3: apache-index.html
Source4: poweredby.png
Source5: httpd.init
Source6: apache.logrotate
Source7: apache-access.conf
Source8: apache-httpd.conf
Source9: apache-srm.conf
Source10: ftp://ftp.cohprog.com/pub/apache/module/1.3.0/mod_bandwidth.c
Source11: mod_put.c
Source12: http://www.snert.com/Software/Throttle/mod_throttle208.tgz
Source13: SSL-Certificate-Creation
Patch0: apache_1.3.12-eapi-2.6.4.patch
Patch1: apache_1.3.12-redhat.patch
Patch2: apache-1.3.11-apxs.patch
Patch3: apache_1.3.12-phhttpd-eapi.patch
Patch4: apache_1.3.12-piranha.patch
Patch5: mod_ssl-2.6.4-tty.patch

Copyright: Freely distributable and usable
BuildRoot: %{_tmppath}/apache-root
BuildPrereq: findutils, openssl-devel, perl
Requires: /etc/mime.types, gawk, file
Prereq: /sbin/chkconfig, /bin/mktemp, /bin/rm, /bin/mv, /bin/sed, mailcap, grep
Prereq: textutils, /usr/sbin/useradd, /etc/init.d
Provides: webserver

%description
Apache is a powerful, full-featured, efficient and freely-available
Web server. Apache is also the most popular Web server on the
Internet.

Install the apache package if you need a Web server.

%package -n mod_ssl
Group: System Environment/Daemons
Version: %{mod_ssl_ver}
Summary: HTTPS (HTTP over SSL) support for the Apache Web server.
Requires: apache = %{apache_ver}-%{release}
Prereq: openssl, dev

%description -n mod_ssl
The mod_ssl package contains mod_ssl %{mod_ssl_ver}, the server module that
adds SSL support to the Apache Web server.  If you need a secure web
server, install this package and read http://localhost/manual/mod/mod_ssl/
for documentation about how to configure the SSL support.

%package devel
Version: %{apache_ver}
Group: Development/Libraries
Summary: Development tools for the Apache Web server.
Obsoletes: secureweb-devel

%description devel
The apache-devel package contains the APXS binary and other files that
you'll need to build Dynamic Shared Objects (DSOs) for Apache.

If you are installing the Apache Web server, and you want to be 
able to compile or develop additional modules for Apache, you'll 
need to install this package.

%package manual
Version: %{apache_ver}
Group: Documentation
Summary: Documentation for the Apache Web server.

%description manual
The apache-manual package contains the complete manual and reference
guide for the Apache Web server.  If you need Apache documentation
installed on the local machine, install this package.  The information
can also be found on the Web at http://www.apache.org/docs/.

%prep
%setup -q -n apache_%{version} -a 1 -a 12
#%patch0 -p1 -b .eapi
pushd mod_ssl-%{mod_ssl_ver}-%{version}
%configure --with-apache=`cd ..;pwd` --with-eapi-only
popd
%patch1 -p1 -b .redhat
%patch2 -p1 -b .apxs
%patch3 -p1 -b .phttpd-eapi
%patch4 -p1 -b .piranha
pushd mod_ssl-%{mod_ssl_ver}-%{version}
%patch5 -p2 -b .tty
popd

%build
TARGET_PLATFORM=%{_target_platform}
%define _target_platform --target=${TARGET_PLATFORM}

pushd mod_ssl-%{mod_ssl_ver}-%{version}
%configure --with-apache=`cd ..;pwd`
popd

./configure \
 	--prefix=%{_prefix} \
 	--exec-prefix=%{_prefix} \
 	--bindir=%{_bindir} \
 	--sbindir=%{_sbindir} \
 	--libexecdir=%{_libdir}/apache \
 	--mandir=%{_mandir} \
 	--localstatedir=%{_localstatedir} \
	--sysconfdir=%{_sysconfdir}/httpd/conf \
	--datadir=%{contentdir} \
	--includedir=%{_includedir}/apache \
	--libexecdir=%{_libdir}/apache \
	--iconsdir=%{contentdir}/icons \
	--htdocsdir=%{contentdir}/html \
	--cgidir=%{contentdir}/cgi-bin \
	--runtimedir=%{_var}/httpd \
	--logfiledir=%{_var}/log/httpd \
	--proxycachedir=%{_var}/cache/httpd \
	--add-module=$RPM_SOURCE_DIR/mod_bandwidth.c \
	--add-module=$RPM_SOURCE_DIR/mod_put.c \
	--activate-module=src/modules/throttle/mod_throttle.o \
	--enable-module=all \
	--enable-shared=max \
	--enable-shared=ssl \
	--enable-rule=EAPI \
	--disable-rule=WANTHSREGEX \
	--disable-module=auth_dbm \
	--with-perl=%{__perl} \
	--enable-suexec \
	--suexec-docroot=%{contentdir}/html \
	--suexec-caller=apache
make
	
%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
%{makeinstall} sysconfdir=$RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf \
	includedir=$RPM_BUILD_ROOT%{_includedir}/apache \
	libexecdir=$RPM_BUILD_ROOT%{_libdir}/apache \
	iconsdir=$RPM_BUILD_ROOT%{contentdir}/icons \
	htdocsdir=$RPM_BUILD_ROOT%{contentdir}/html \
	cgidir=$RPM_BUILD_ROOT%{contentdir}/cgi-bin \
	runtimedir=$RPM_BUILD_ROOT%{_var}/httpd \
	logfiledir=$RPM_BUILD_ROOT%{_var}/log/httpd \
	proxycachedir=$RPM_BUILD_ROOT%{_var}/cache/httpd

# remove apachectl; we have our own SYSV init stuff
rm $RPM_BUILD_ROOT%{_sbindir}/apachectl
rm $RPM_BUILD_ROOT%{_mandir}/man8/apachectl.8

# install SYSV init stuff
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m755 $RPM_SOURCE_DIR/httpd.init \
	$RPM_BUILD_ROOT/etc/rc.d/init.d/httpd

# install log rotation stuff
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
install -m644 $RPM_SOURCE_DIR/apache.logrotate \
	$RPM_BUILD_ROOT/etc/logrotate.d/apache

ln -s ../../var/log/httpd $RPM_BUILD_ROOT/etc/httpd/logs
ln -s ../../usr/lib/apache $RPM_BUILD_ROOT/etc/httpd/modules

install -m644 $RPM_SOURCE_DIR/apache-index.html \
        $RPM_BUILD_ROOT%{contentdir}/html/index.html
install -m644 $RPM_SOURCE_DIR/poweredby.png \
	$RPM_BUILD_ROOT%{contentdir}/html

# replace Apache's default config files with our own versions
install -m644 $RPM_SOURCE_DIR/apache-access.conf \
	$RPM_BUILD_ROOT/etc/httpd/conf/access.conf

install -m644 $RPM_SOURCE_DIR/apache-httpd.conf \
	$RPM_BUILD_ROOT/etc/httpd/conf/httpd.conf

install -m644 $RPM_SOURCE_DIR/apache-srm.conf \
	$RPM_BUILD_ROOT/etc/httpd/conf/srm.conf

# Remove default keys and certs, install docs, and point to the right makefile.
mkdir -p $RPM_BUILD_ROOT%{contentdir}/html/manual/mod/mod_ssl/
install -m644 mod_ssl-%{mod_ssl_ver}-%{version}/pkg.ssldoc/*.{html,gif,jpg} \
	$RPM_BUILD_ROOT%{contentdir}/html/manual/mod/mod_ssl/
rm -f $RPM_BUILD_ROOT/etc/httpd/conf/ssl.*/server.*
ln -s ../../../usr/share/ssl/certs/Makefile $RPM_BUILD_ROOT/etc/httpd/conf

# install apache source code for devel package
#mkdir -p $RPM_BUILD_ROOT/usr/src
#tar xzf $RPM_SOURCE_DIR/apache_%{version}.tar.gz -C $RPM_BUILD_ROOT/usr/src
find $RPM_BUILD_ROOT -type f | \
	xargs grep -l "/usr/local/bin/perl5" | \
	xargs perl -pi -e "s|/usr/local/bin/perl5|/usr/bin/perl|g;"
find $RPM_BUILD_ROOT -type f | \
	xargs grep -l "/usr/local/bin/perl" | \
	xargs perl -pi -e "s|/usr/local/bin/perl|/usr/bin/perl|g;"

# clean up apxs
sed "s^$RPM_BUILD_ROOT^^g" $RPM_BUILD_ROOT%{_sbindir}/apxs > apxs.tmp && \
cat apxs.tmp > $RPM_BUILD_ROOT%{_sbindir}/apxs

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add httpd
# safely add .htm to mime types if it is not already there
[ -f /etc/mime.types ] || exit 0
TEMPTYPES=`/bin/mktemp /tmp/mimetypes.XXXXXX`
[ -z "$TEMPTYPES" ] && {
  echo "could not make temporary file, htm not added to /etc/mime.types" >&2
  exit 1
}
( grep -v "^text/html"  /etc/mime.types
  types=$(grep "^text/html" /etc/mime.types | cut -f2-)
  echo -en "text/html\t\t\t"
  for val in $types ; do
      if [ "$val" = "htm" ] ; then
          continue
      fi
      echo -n "$val "
  done
  echo "htm"
) > $TEMPTYPES
cat $TEMPTYPES > /etc/mime.types && /bin/rm -f $TEMPTYPES

%pre
# Add the "apache" user
/usr/sbin/useradd -c "Apache" -u 48 \
	-s /bin/false -r -d /var/www apache 2> /dev/null || :

%preun
if [ $1 = 0 ]; then
	/sbin/service httpd stop > /dev/null 2>&1
	/sbin/chkconfig --del httpd
fi
  
%files
%defattr(-,root,root)
%dir /etc/httpd/conf
%config /etc/httpd/conf/access.conf
%config /etc/httpd/conf/srm.conf
%config /etc/httpd/conf/httpd.conf

/etc/httpd/logs
/etc/httpd/modules
%config /etc/logrotate.d/apache
%config /etc/rc.d/init.d/httpd

%dir %{contentdir}
%{contentdir}/cgi-bin
%dir %{contentdir}/html
%config(noreplace) %{contentdir}/html/index.html
%{contentdir}/html/poweredby.png
%{contentdir}/icons

%dir %{_libdir}/apache
%{_libdir}/apache/httpd.exp
%{_libdir}/apache/libproxy.so
%{_libdir}/apache/mod*.so

%{_mandir}/man1/*
%{_mandir}/man8/ab.8*
%{_mandir}/man8/httpd.8*
%{_mandir}/man8/logresolve.8*
%{_mandir}/man8/rotatelogs.8*
%{_mandir}/man8/suexec.8*

%{_sbindir}/ab
%{_sbindir}/httpd
%{_sbindir}/logresolve
%{_sbindir}/rotatelogs
%attr(0711,root,root) %{_sbindir}/suexec
%{_bindir}/*

%attr(-,apache,apache) %dir %{_var}/cache/httpd
%dir %{_var}/log/httpd

%files manual
%defattr(-,root,root)
%dir %{contentdir}/html/manual
%{contentdir}/html/manual/LICENSE
%{contentdir}/html/manual/*.html
%{contentdir}/html/manual/images
%{contentdir}/html/manual/misc
%{contentdir}/html/manual/search
%{contentdir}/html/manual/vhosts
%dir %{contentdir}/html/manual/mod
%{contentdir}/html/manual/mod/*.html

%files devel
%defattr(-,root,root)
%{_includedir}/apache
%{_sbindir}/apxs
%{_mandir}/man8/apxs.8*

%post -n mod_ssl
/sbin/ldconfig
umask 077

if [ ! -f %{_sysconfdir}/httpd/conf/ssl.key/server.key ] ; then
%{_bindir}/openssl genrsa -rand /proc/apm:/proc/cpuinfo:/proc/dma:/proc/filesystems:/proc/interrupts:/proc/ioports:/proc/pci:/proc/rtc:/proc/uptime 1024 > %{_sysconfdir}/httpd/conf/ssl.key/server.key 2> /dev/null
fi

if [ ! -f %{_sysconfdir}/httpd/conf/ssl.crt/server.crt ] ; then
cat << EOF | %{_bindir}/openssl req -new -key %{_sysconfdir}/httpd/conf/ssl.key/server.key -x509 -days 365 -out %{_sysconfdir}/httpd/conf/ssl.crt/server.crt 2>/dev/null
--
SomeState
SomeCity
SomeOrganization
SomeOrganizationalUnit
localhost.localdomain
root@localhost.localdomain
EOF
fi

%files -n mod_ssl
%defattr(-,root,root)
%doc $RPM_SOURCE_DIR/SSL-Certificate-Creation
%{contentdir}/html/manual/mod/mod_ssl/
%{_libdir}/apache/libssl.so
%{_sysconfdir}/httpd/conf/Makefile
%attr(0700,root,root) %dir %{_sysconfdir}/httpd/conf/ssl.*
%{_sysconfdir}/httpd/conf/ssl.*/*
  
%changelog
* Wed Aug 23 2000 Nalin Dahyabhai <nalin@redhat.com>
- fix mod_ssl package's version
- generate keys more quickly by using files from /proc instead of /dev/mem
- make mod_ssl require Apache %%{version}-%%{release} specifically

* Tue Aug 15 2000 Nalin Dahyabhai <nalin@redhat.com>
- change <Location /> to <Directory /var/www/html> (#16196)
- build suexec with user apache (#16188)
- change owner of cache directory to "apache"

* Mon Aug 14 2000 Nalin Dahyabhai <nalin@redhat.com>
- use the default magic file instead of Apache's (again) (#15895)
- update to mod_ssl 2.6.6 -- "Segfault fixes! Upgrade, please."

* Mon Aug 07 2000 Nalin Dahyabhai <nalin@redhat.com>
- enable mod_auth, mod_auth_anon, mod_auth_db modules by default like 6.2

* Sun Jul 18 2000 Nalin Dahyabhai <nalin@redhat.com>
- more fully-formed useradd invocation

* Sat Jul 15 2000 Bill Nottingham <notting@redhat.com>
- move initscript back

* Wed Jul 12 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Mon Jul 10 2000 Nalin Dahyabhai <nalin@redhat.com>
- fix ServerToken vs signature string bug (#13678)

* Fri Jul  7 2000 Nalin Dahyabhai <nalin@redhat.com>
- fix config file for change from <Directory (DocumentRoot)> to <Location />
- tighten up permissions on SSL configuration files
- build default SSL certificate at install-time

* Thu Jul  6 2000 Nalin Dahyabhai <nalin@redhat.com>
- change initscripts dependency to /etc/init.d

* Wed Jul  5 2000 Nalin Dahyabhai <nalin@redhat.com>
- stop trying to detect weird upgrade scenarios and mucking with document roots
- update to mod_ssl 2.6.5

* Mon Jul  3 2000 Nalin Dahyabhai <nalin@redhat.com>
- only change the document root if we found an old installation

* Sun Jul  2 2000 Nalin Dahyabhai <nalin@redhat.com>
- take another shot at fixing tty handling
- force LANG to "C" in the init script until glibc's locale support gets fixed
- integrate new EAPI patch with phttpd patch
- remove condrestart from post and postuns

* Sat Jul  1 2000 Nalin Dahyabhai <nalin@redhat.com>
- switch to the "apache" user
- fix tty handling when prompting for pass-phrases in mod_ssl

* Fri Jun 30 2000 Nalin Dahyabhai <nalin@redhat.com>
- tweak graceful restarting code in the init script to return error codes

* Thu Jun 29 2000 Nalin Dahyabhai <nalin@redhat.com>
- link to the makefile from openssl for certificate-creation

* Wed Jun 28 2000 Nalin Dahyabhai <nalin@redhat.com>
- support for smooth upgrades
- move init script to /etc/init.d

* Mon Jun 19 2000 Nalin Dahyabhai <nalin@redhat.com>
- rebuild to pull in the newly-corrected dependencies

* Fri Jun 16 2000 Nalin Dahyabhai <nalin@redhat.com>
- fix syntax error introduced in init script

* Thu Jun 15 2000 Nalin Dahyabhai <nalin@redhat.com>
- init script: add condrestart

* Thu Jun  8 2000 Nalin Dahyabhai <nalin@redhat.com>
- modified logrotate configuration file to use /var/run/httpd.pid, so don't
  move it to another directory!

* Sun Jun  4 2000 Nalin Dahyabhai <nalin@redhat.com>
- rework packaged module behavior
- move document root from /home/httpd to /var/www with fixups in %post
- FHS fixes

* Wed Mar 01 2000 Nalin Dahyabhai <nalin@redhat.com>
- make suexec limit UIDs and GIDs to < 51 instead of 100

* Fri Feb 25 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to 1.3.12
- add EAPI patch

* Thu Feb 17 2000 Preston Brown <pbrown@redhat.com>
- ifmodule directive for php stuff.
- load mod_perl before mod_php (#8169)

* Tue Feb 14 2000 Zach Brown <zab@redhat.com>
- minor fix to phhttpd patch

* Thu Feb 10 2000 Preston Brown <pbrown@redhat.com>
- improved default index.html.

* Thu Feb 03 2000 Preston Brown <pbrown@redhat.com>
- strip dynamically loadable modules.

* Mon Feb 02 2000 Zach Brown <zab@redhat.com>
- add phhttpd 'Tunnel' directive and code to use it

* Mon Jan 31 2000 Cristian Gafton <gafton@redhat.com>
- rebuild to fix depenencies

* Tue Jan 25 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 1.3.11
- deal with the fact that RPM now gzips man pages

* Wed Jan 12 2000 Preston Brown <pbrown@redhat.com>
- new poweredby.png w/new logo
- apxs.8 man page moved to devel archive (#6661)
- don't remove old logfiles on package de-install (#8268)
- more updates to logrotate to avoid spurious cron mail (#8110)

* Mon Jan 10 2000 Preston Brown <pbrown@redhat.com>
- mod_throttle added; mod_bandwidth updated.

* Mon Dec 17 1999 Dale Lovelace <dale@redhat.com>
- Add configuration for mod_put to httpd.conf

* Mon Dec 06 1999 Preston Brown <pbrown@redhat.com>
- documentation cleanups in httpd.conf (#5357, #6655)
- fixed logrotate script to ignore error if no apache running (#7074)

* Wed Nov 10 1999 Jeff Johnson <jbj@redhat.com>
- add put module.

* Thu Nov 04 1999 Preston Brown <pbrown@redhat.com>
- make suexec non-suid.  People can enable it if they wish themselves.
- somehow the unified httpd.conf got trashed.  fixed.
- manual is now a subpackage
- point to /usr/share/magic as the magic file location; don't use the
  apache-specific one.
- fix apxs module installation issues (#5650)

* Tue Sep 21 1999 Bill Nottingham <notting@redhat.com>
- move DSO in httpd.conf to after ServerRoot

* Mon Sep 20 1999 Preston Brown <pbrown@redhat.com>
- it is httpd stop, not httpsd stop (# 5254)
- suexec added (# 5257)

* Thu Sep 09 1999 Preston Brown <pbrown@redhat.com>
- remove apachectl man page (# 4459)

* Fri Aug 27 1999 Preston Brown <pbrown@redhat.com>
- upgraded to 1.3.9
- fix bug # 3680 (suexec docroot was wrong)
- fix bug # 2378 (logrotate with -USR1 not -HUP)
- fix bug # 3548 (logrotate complains if apache not running)
- httpd.conf is now in the unified apache format as distributed

* Mon Aug 16 1999 Bill Nottingham <notting@redhat.com>
- initscript munging

* Sat May 21 1999 Bill Nottingham <notting@redhat.com>
- fix broken link in index.html

* Wed Apr 07 1999 Bill Nottingham <notting@redhat.com>
- allow indexes in /doc

* Tue Apr 06 1999 Preston Brown <pbrown@redhat.com>
- strip binaries

* Mon Apr 05 1999 Preston Brown <pbrown@redhat.com>
- prerequire /bin/rm, added /doc path pointing to /usr/doc for localhost

* Fri Mar 26 1999 Preston Brown <pbrown@redhat.com>
- updated log rotating scripts to not complain if logs aren't present.

* Thu Mar 25 1999 Preston Brown <pbrown@redhat.com>
- fixed up path to perl

* Wed Mar 24 1999 Preston Brown <pbrown@redhat.com>
- updated init script to conform to new standards
- upgraded to 1.3.6, fixed apxs patch

* Mon Mar 22 1999 Preston Brown <pbrown@redhat.com>
- clean up logfiles on deinstallation

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 4)

* Fri Mar 12 1999 Cristian Gafton <gafton@redhat.com>
- added mod_bandwidth
- updated to 1.3.4
- prereq mailcap

* Fri Dec 18 1998 Cristian Gafton <gafton@redhat.com>
- added patch to disable building support for ndbm
- build against glibc 2.1

* Mon Oct 12 1998 Cristian Gafton <gafton@redhat.com>
- updated to 1.3.3 to catch up with bug fixes
- added the /usr/bin/* binaries to the spec file list

* Fri Sep 25 1998 Cristian Gafton <gafton@redhat.com>
- change ownership of cache dir to nobody
- added "Red Hat" to the server string
- updated to version 1.3.2
- fixed all references to httpsd in config files

* Fri Sep 04 1998 Cristian Gafton <gafton@redhat.com>
- small fixes to the spec file
- patch to handle correctly the -d <newroot> option
- leave out the .usr.src.apache_%{version} for now

* Thu Sep 03 1998 Preston Brown <pbrown@redhat.com>
- patched apxs not to bomb out if it can't find httpd

* Wed Sep 02 1998 Preston Brown <pbrown@redhat.com>
- upgraded to apache 1.3.1.
- Heavy rewrite.
- changed providing a_web_server to just webserver.  Humor is not an option.

* Mon Aug 10 1998 Erik Troan <ewt@redhat.com>
- updated to build as non-root user
- added patch to defeat header dos attack

* Thu May 07 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Wed May 06 1998 Cristian Gafton <gafton@redhat.com>
- fixed the default config files to be more paranoid about security

* Sat May 02 1998 Cristian Gafton <gafton@redhat.com>
- fixed init script
- added index.htm to the list of acceptable indexes

* Sat May 02 1998 Cristian Gafton <gafton@redhat.com>
- updated to 1.2.6
- added post script to install htm extension for text/html into
  /etc/mime.types

* Wed Apr 22 1998 Michael K. Johnson <johnsonm@redhat.com>
- enhanced sysv init script

* Tue Jan 06 1998 Erik Troan <ewt@redhat.com>
- updated to 1.2.5, which includes many security fixes

* Wed Dec 31 1997 Otto Hammersmith <otto@redhat.com>
- fixed overkill on http.init stop

* Wed Dec 31 1997 Erik Troan <ewt@redhat.com>
- added patch for backslash DOS attach

* Thu Nov 06 1997 Donnie Barnes <djb@redhat.com>
- added htdigest binary to file list

* Mon Nov 03 1997 Donnie Barnes <djb@redhat.com>
- made the default index.html be config(noreplace) so we no longer
  blow away other folks' index.html

* Wed Oct 29 1997 Donnie Barnes <djb@redhat.com>
- added chkconfig support
- added restart|status options to initscript
- renamed httpd.init to httpd

* Tue Oct 07 1997 Elliot Lee <sopwith@redhat.com>
- Redid spec file, patches, etc. from scratch.
